/*********************************************************************
 *
 ************************************************************************/

#define	VERSION			"0.1b"
#define	DATE			"95-7-29"

#define		DIRECT			1
#define		NEGATED			2
/*#define		DONT_CARE		3	*/

#define		NEGATION_STR		"/"
#define 	AND_STR			"*"
#define		OR_STR			"+"

#define 	COMMENT_STR		"#"

#define		SIGNALS_STR		"SIGNALS"
#define		EQUATION_STR		"EQUATION"

#define		MAX_NUMBER_OF_SIGNALS	(8 * sizeof(long))

#define		DON_T_CARE_FLAG		-1
#define		CLR_FLAG		-2
#define		ESSENTIAL_FLAG		-3
#define		SELECT_FLAG		-4


#define		CMD_ID			'-'
#define		CMD_OUTPUT_FILE		"o"
#define		CMD_NO_DONT_CARE	"NODC"
#define		CMD_NO_SYSM_LIST	"NOSYM"
#define		CMD_NOT_ADD_MIN_TERMS	"NOMT"
#define		CMD_SILENT		"SILENT"


#define		EXTENSION		".qmc"

/*------------- global Flags -------------------------*/
extern int NoDontCares;
extern int NoSymbolList;
extern int NotAddMinTerms;
extern int Silent;

typedef struct SignalListElement SIGNAL_LIST_ELEMENT;   
struct SignalListElement { 
	char			*Identifier;
	int			Idx;
	SIGNAL_LIST_ELEMENT	*Successor, *Predecessor;
};

typedef struct MinTermListElement MIN_TERM_LIST_ELEMENT;   
struct MinTermListElement { 
	unsigned long		DontCares;
	unsigned long		MinTerm;
	int			InputLineNo;
	char 			*IdxArray;
	int			Flag;
	int			Value;
	MIN_TERM_LIST_ELEMENT	*Successor, *Predecessor;
};

struct MinTermsStruct {
	MIN_TERM_LIST_ELEMENT	*StartOfListOfMinTerms, *EndOfListOfMinTerms;
    };
typedef struct MinTermsStruct MIN_TERM_STRUCT;
    
extern MIN_TERM_STRUCT MinTerms[MAX_NUMBER_OF_SIGNALS+1];
	
extern char			*OutputName;
extern char			OutputPolaritiy;
	
extern FILE 			*yyin;
extern int 			yylineno;

extern int 			NumberOfSignals;
extern SIGNAL_LIST_ELEMENT	*StartOfListOfSignals, *EndOfListOfSignals;

extern int 			DontCareIdx;
extern int			MinTermIdx;
extern int			SizeOfIdxArray;
extern MIN_TERM_LIST_ELEMENT	*ActualMinTerm;
extern MIN_TERM_LIST_ELEMENT	*ActualDontCare;

extern char			*PrgName;
extern char			*InputFileName;
extern char			*OutputFileName;


extern char			*AssignmentStr;



