/*********************************************************
 * project:     qmc -- minimize dnf using the Quine McCluskey algorithem
 * file:        parserfctn.h
 * version:     0.1
 * date:        july, 22. 1995
 * author:      volker bosch (volker.bosch@z.zgs.de)
 *************************************************************************/

/*------------------------------------
 * print first part of parser error message
 *------------------------------------------------*/
int yyerror(char *);

/*------------------------------------
 * print second part of parser error message, 
 * abort program
 *--------------------------------------------------*/
int YaccErrMsg(char *);

/*------------------------------------------- 
 * Put identifier into list of signals to keep the relation of
 * signal name and postition number.
 * Count number of signals
 *---------------------------------------------------------------------*/
void AddSignalId(char *);

/*----------------------------------------------------
 * 
 *-----------------------------------------------------------------*/
void InsertActualMinTerm(void);

/*-----------------------------------------------
 *
 *------------------------------------------------------------------*/
void NewMinTerm(int);

/*-----------------------------------------------
 *
 *------------------------------------------------------------------*/
void AddToMinTerm(char, char *);

/*----------------------------------------------------
 * 
 *-----------------------------------------------------------------*/
void InsertActualDontCare(void);

/*-----------------------------------------------                      
 *
 *------------------------------------------------------------------*/
void NewDontCare(int);

/*-----------------------------------------------
 *
 *------------------------------------------------------------------*/
void AddToDontCare(char, char *);

/*-----------------------------------------------
 *
 *------------------------------------------------------------------*/
void GetOutput(char *, char);
  
void CheckOutput(char *, char);
